import urllib2
import json
import datetime
import os.path

updateDictionaryFile = open('updateStatus.json')
updateDictionary = {}
if updateDictionaryFile:
  updateDictionary = json.loads(updateDictionaryFile.read())
updateDictionaryFile.close()


queryBase = "http://discoapp.stanford.edu/erddap/tabledap/discoApp.json?toppid,ptt,fin_id,receiver,code,time,latitude,longitude,rt"
sightingsURL = queryBase + "&time>=2006-01-21T00:00:00Z&time<=2012-08-01T00:00:00Z&orderBy(%22time%22)"
sharksURL = queryBase + "&time>=2006-01-21T00:00:00Z&distinct()&orderBy(%22code%22)&orderByMax(%22code,time%22)"
buoysURL = queryBase + "&time>=2008-01-21T00:00:00Z&distinct()&orderBy(%22receiver%22)&orderByMax(%22receiver,time%22)"

tracksURL = "http://discoapp2.stanford.edu/erddap/tabledap/discoApp2.json?toppid,time,latitude,longitude,depth,pop&time>=2001-07-13T00:00:00Z&orderBy(%22toppid,time%22)"
sharkMediaURL = 'http://s3.amazonaws.com/toppMedia/json/sharkWatch2.json'
buoyMediaURL = 'http://s3.amazonaws.com/toppMedia/json/locations.json'


def pprint(rows):
  result = "["
  for row in rows:
    if len(result) > 1:
      result += ","
    result += "\n  " + json.dumps(row) 
  result += "\n]\n"
  
  return result
    
def downloadFile(url, filetype):
  
  filename = filetype + ".json"
  try:
    response = urllib2.urlopen(url)
    text = response.read()
    resultJson = json.loads(text)
    
    x = text
    if filetype != "shark_media" and filetype != 'buoy_media':
      x = pprint(resultJson['table']['rows'])
    
    try:
      f = open(filename, 'r')
      oldText = f.read()
      f.close()
      if (oldText == x):
        print "%s unchanged" % filetype
        return True
    except:
      #old file doesnt exist
      None
    f = open(filename, 'w')
    f.write(x)
    f.close()
    print "Completed " + filename
    updateDictionary[filetype] = datetime.datetime.utcnow().strftime('%Y-%m-%dT%H:%M:%SZ')
    return True
  except Exception as e:
    print e
    print "Fetching " + filename + " failed"
    return False
  
def attemptToDownloadFile(url, filename):
  x = 0
  while x < 1 and not downloadFile(url, filename):
    x += 1
  
attemptToDownloadFile(buoysURL, "allbuoys")

attemptToDownloadFile(sightingsURL, "allsightings")

attemptToDownloadFile(sharksURL, "allsharks")

attemptToDownloadFile(tracksURL, "trackdata")

attemptToDownloadFile(sharkMediaURL, "shark_media")

attemptToDownloadFile(buoyMediaURL, "buoy_media")
	
f = open('updateStatus.json', 'w')
f.write(json.dumps(updateDictionary))
f.close()

